﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.Practices.Unity;

namespace Lib.Web.Mvc.Unity
{
    public class UnityDependencyResolver : IDependencyResolver
    {
        #region Fields
        private IUnityContainer _container;
        #endregion

        #region Constructor
        public UnityDependencyResolver(IUnityContainer container)
        {
            _container = container;
        }
        #endregion

        #region IDependencyResolver Members
        public object GetService(Type serviceType)
        {
            try
            {
                return _container.Resolve(serviceType);
            }
            catch
            {
                return null;
            }
        }

        public IEnumerable<object> GetServices(Type serviceType)
        {
            try
            {
                return _container.ResolveAll(serviceType);
            }
            catch
            {
                return new List<object>();
            }
        }
        #endregion
    }
}
