﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace jqGrid.Models.NorthWind
{
    public interface IProductsRepository
    {
        int GetProductsCount(string filterExpression);

        IQueryable<Product> GetProducts(string filterExpression, string sortExpression, string sortDirection, int pageIndex, int pageSize, int pagesCount);

        IQueryable<Product> GetProducts(string filterExpression);
        
        Product GetProduct(int productId);
        
        bool DeleteProduct(int productId);
        
        bool AddProduct(Product newProduct);

        void SubmitChanges();
    }
}