﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Lib.Web.Mvc.JQuery.JqGrid;

namespace jqGrid
{
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            routes.MapRoute("Default", "{controller}/{action}", new { controller = "Home", action = "Formatting" });
        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);

            JqGridRequest.ParameterNames = new JqGridParametersNames() { PagesCount = "npage" };
            JqGridResponse.JsonReader.RepeatItems = false;
            JqGridResponse.JsonReader.RecordId = "Id";
            JqGridResponse.JsonReader.SubgridReader.RepeatItems = false;
        }
    }
}