﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using Lib.Web.Mvc.JQuery.JqGrid.DataAnnotations;
using Lib.Web.Mvc.JQuery.JqGrid;
using System.ComponentModel.DataAnnotations;
using Northwind.Model;
using Lib.Web.Mvc.JQuery.JqGrid.Constants;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace jqGrid.Models
{
    public class ProductFormattedViewModel
    {
        #region Properties
        public int Id { get; set; }

        public string Name { get; set; }

        [JqGridColumnSortable(true, Index = "SupplierId")]
        [JqGridColumnFormatter("$.supplierFormatter")]
        public string Supplier { get; set; }

        public string Category { get; set; }

        [DisplayName("Quantity Per Unit")]
        [JqGridColumnLayout(Alignment = JqGridAlignments.Center)]
        public string QuantityPerUnit { get; set; }

        [DisplayName("Unit Price")]
        [JqGridColumnLayout(Alignment = JqGridAlignments.Center)]
        [JqGridColumnSummary(JqGridColumnSummaryTypes.Avg, Template = "Avg Unit Price: {0}")]
        [JqGridColumnFormatter(JqGridColumnPredefinedFormatters.Currency, DecimalPlaces = 2, DecimalSeparator = ".", Prefix = "$")]
        public decimal? UnitPrice { get; set; }

        [DisplayName("Units In Stock")]
        [JqGridColumnLayout(Alignment = JqGridAlignments.Center)]
        [JqGridColumnFormatter("$.unitsInStockFormatter")]
        public short? UnitsInStock { get; set; }
        #endregion

        #region Constructor
        public ProductFormattedViewModel()
        { }

        public ProductFormattedViewModel(Product product)
        {
            this.Id = product.Id;
            this.Name = product.Name;
            this.Supplier = String.Format("[{0}] {1}", product.SupplierId, product.Supplier.Name);
            this.Category = product.Category.Name;
            this.QuantityPerUnit = product.QuantityPerUnit;
            this.UnitPrice = product.UnitPrice;
            this.UnitsInStock = product.UnitsInStock;
        }
        #endregion
    }
}