﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace jQuery.Treeview
{
    public partial class PageMethod : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        { }

        [System.Web.Services.WebMethod]
        public static List<TreeViewNode> FileSystemInfos(string root)
        {
            int? nodeId = (root == "source") ? (int?)null : Convert.ToInt32(root);
            IEnumerable<FileSystemInfo> children = FileSystemInfosRepository.GetFileSystemInfos(nodeId);

            List<TreeViewNode> nodes = new List<TreeViewNode>();
            foreach (FileSystemInfo child in children)
            {
                bool leaf = child is FileInfo;
                nodes.Add(new TreeViewNode()
                {
                    id = Convert.ToString(FileSystemInfosRepository.GetNodeId(child)),
                    text = child.Name,
                    classes = leaf ? "file" : "folder",
                    hasChildren = !leaf
                });
            }

            return nodes;
        }
    }
}