﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lib.Web.Mvc.JQuery.JqGrid.Constants
{
    /// <summary>
    /// Contains default values for jqGrid Navigator properties
    /// </summary>
    public static class JqGridNavigatorDefaults
    {
        /// <summary>
        /// The icon (form UI theme images) for add action
        /// </summary>
        public const string AddIcon = "ui-icon-plus";

        /// <summary>
        /// The tooltip for add action.
        /// </summary>
        public const string AddToolTip = "Add new row";

        /// <summary>
        /// The caption for warning which appears when user try to edit, delete or view a row without selecting it.
        /// </summary>
        public const string AlertCaption = "Warning";

        /// <summary>
        /// The text for warning which appears when user try to edit, delete or view a row without selecting it.
        /// </summary>
        public const string AlertText = "Please, select row";

        /// <summary>
        /// The icon (form UI theme images) for cancel action.
        /// </summary>
        public const string CancelIcon = "ui-icon-cancel";

        /// <summary>
        /// The tooltip for cancel action.
        /// </summary>
        public const string CancelToolTip = "Cancel row editing";

        /// <summary>
        /// The icon (form UI theme images) for delete action.
        /// </summary>
        public const string DeleteIcon = "ui-icon-trash";

        /// <summary>
        /// The tooltip for delete action.
        /// </summary>
        public const string DeleteToolTip = "Delete selected row";

        /// <summary>
        /// The icon (form UI theme images) for edit action.
        /// </summary>
        public const string EditIcon = "ui-icon-pencil";

        /// <summary>
        /// The tooltip for edit action.
        /// </summary>
        public const string EditToolTip = "Edit selected row";

        /// <summary>
        /// The icon (form UI theme images) for refresh action.
        /// </summary>
        public const string RefreshIcon = "ui-icon-refresh";

        /// <summary>
        /// The tooltip for refresh action.
        /// </summary>
        public const string RefreshToolTip = "Reload Grid";

        /// <summary>
        /// The icon (form UI theme images) for save action.
        /// </summary>
        public const string SaveIcon = "ui-icon-disk";

        /// <summary>
        /// The tooltip for save action.
        /// </summary>
        public const string SaveToolTip = "Save row";

        /// <summary>
        /// The icon (form UI theme images) for search action.
        /// </summary>
        public const string SearchIcon = "ui-icon-search";

        /// <summary>
        /// The tooltip for search action.
        /// </summary>
        public const string SearchToolTip = "Find records";

        /// <summary>
        /// The icon (form UI theme images) for view action.
        /// </summary>
        public const string ViewIcon = "ui-icon-document";

        /// <summary>
        /// The tooltip for view action.
        /// </summary>
        public const string ViewToolTip = "View selected row";

        /// <summary>
        /// The caption of the button.
        /// </summary>
        public const string ButtonCaption = "NewButton";

        /// <summary>
        /// The icon (form UI theme images) of the button.
        /// </summary>
        public const string ButtonIcon = "ui-icon-newwin";

        /// <summary>
        /// The value which determines the cursor when user mouseover the button.
        /// </summary>
        public const string ButtonCursor = "pointer";

        /// <summary>
        /// The class for the separator.
        /// </summary>
        public const string SeparatorClass = "ui-separator";

        /// <summary>
        /// The row id for new row.
        /// </summary>
        public const string NewRowId = "new_row";
    }
}
